import { __values } from "tslib";
var globalCopy = global;
var currentSdk = {
    // tslint:disable-next-line: no-empty
    request: function () {
    },
    // tslint:disable-next-line: no-empty
    httpRequest: function () {
    },
    // tslint:disable-next-line: no-empty
    getSystemInfoSync: function () {
    },
    // tslint:disable-next-line: no-empty
    getSystemInfo: function () {
    },
};
// tslint:disable-next-line:no-implicit-dependencies no-var-requires
var fetch = require('@system.fetch');
/**
 * 获取跨平台的 SDK
 */
var getSDK = function () {
    if (typeof uni === "object") {
        currentSdk = uni;
    }
    else if (typeof wx === "object") {
        currentSdk = uni;
    }
    else if (typeof my === "object") {
        currentSdk = my;
    }
    else if (typeof tt === "object") {
        currentSdk = tt;
    }
    else if (typeof dd === "object") {
        currentSdk = dd;
    }
    else if (typeof qq === "object") {
        currentSdk = qq;
    }
    else if (typeof swan === "object") {
        currentSdk = swan;
    }
    else if (typeof fetch === 'object') {
        // 针对快应用的兼容性封装
        globalCopy.getCurrentPages = function () {
            var e_1, _a;
            // tslint:disable-next-line:no-implicit-dependencies
            var router = require('@system.router');
            var stacks = router.getPages();
            var ret = [];
            try {
                for (var stacks_1 = __values(stacks), stacks_1_1 = stacks_1.next(); !stacks_1_1.done; stacks_1_1 = stacks_1.next()) {
                    var route = stacks_1_1.value;
                    ret.push({
                        route: route.path,
                        options: {},
                    });
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (stacks_1_1 && !stacks_1_1.done && (_a = stacks_1.return)) _a.call(stacks_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return ret;
        };
        currentSdk.request = fetch.fetch;
        currentSdk.getSystemInfo = function () {
            return new Promise(function (resolve, reject) {
                // tslint:disable-next-line:no-implicit-dependencies
                var app = require('@system.app');
                var appInfo = app.getInfo();
                // tslint:disable-next-line:no-implicit-dependencies
                var device = require('@system.device');
                // tslint:disable-next-line:no-implicit-dependencies
                var battery = require('@system.battery');
                var ret = {
                    version: appInfo.versionName,
                    battery: 0,
                    batteryLevel: 0,
                    currentBattery: 0,
                    appName: appInfo.name,
                    system: '',
                    model: String,
                    brand: String,
                    platform: String,
                    screenHeight: Number,
                    screenWidth: Number,
                    statusBarHeight: Number,
                    language: String,
                    windowWidth: Number,
                    windowHeight: Number,
                    fontSizeSetting: '',
                };
                device.getInfo({
                    // tslint:disable-next-line:no-shadowed-variable
                    success: function (deviceInfo) {
                        ret.language = deviceInfo.language;
                        ret.brand = deviceInfo.brand;
                        ret.model = deviceInfo.model;
                        ret.platform = deviceInfo.platformVersionName;
                        ret.screenHeight = deviceInfo.screenHeight;
                        ret.screenWidth = deviceInfo.screenWidth;
                        ret.statusBarHeight = deviceInfo.statusBarHeight;
                        ret.windowHeight = deviceInfo.windowHeight;
                        ret.windowWidth = deviceInfo.windowWidth;
                        ret.system = deviceInfo.osType + " " + deviceInfo.osVersionName;
                        battery.getStatus({
                            success: function (batteryStatus) {
                                ret.currentBattery = batteryStatus.level;
                                resolve(ret);
                            },
                            fail: function (e) {
                                reject(e);
                            }
                        });
                    },
                    fail: function (e) {
                        reject(e);
                    }
                });
            });
        };
    }
    else {
        // tslint:disable-next-line:no-console
        console.log("sentry-uniapp 暂不支持此平台");
    }
    return currentSdk;
};
/**
 * 获取平台名称
 */
var getAppName = function () {
    var currentAppName = "unknown";
    if (typeof uni === "object") {
        currentAppName = "uniapp";
    }
    else if (typeof wx === "object") {
        currentAppName = "wechat";
    }
    else if (typeof my === "object") {
        currentAppName = "alipay";
    }
    else if (typeof tt === "object") {
        currentAppName = "bytedance";
    }
    else if (typeof dd === "object") {
        currentAppName = "dingtalk";
    }
    else if (typeof qq === "object") {
        currentAppName = "qq";
    }
    else if (typeof swan === "object") {
        currentAppName = "swan";
    }
    else if (typeof fetch === "object") {
        currentAppName = "quickapp";
    }
    return currentAppName;
};
var sdk = getSDK();
var appName = getAppName();
export { sdk, appName };
//# sourceMappingURL=crossPlatform.js.map